<div></div>

<div id='calendar{{ .Ordinal }}' 
{{ if eq "true" ( .Get "tiny" ) }}class="tinycalendar pull-right"{{ end }}></div>

<script>

$(function() {

    let urls = '{{ .Get "urls" }}'.split(',');
    let colors = '{{ .Get "colors" }}'.split(',');

    let tiny = ('true' === '{{ if .Get "tiny" }}true{{ else }}false{{ end }}');

    let promises = [];

    /** remplacer les URL par des balises HTML a */
    function replaceUrls(text) {
        if (text == null) return null;
        const reg = /(https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()!@:%_\+.~#?&\/\/=]*))/g;
        return text.replace(reg, '<a href=\'$1\'>$1</a>');
    }

    for (var i = 0; i < urls.length; i++) {
        promises.push($.ajax(urls[i]));
    }
    $.when.apply($, promises).then(function() {
        let eventSources = [];

        for (var i = 0; i < urls.length; i++) {
            if (urls.length == 1) {
                var data = arguments[0];
            } else {
                var data = arguments[i][0];
            }

            var jcalData = ICAL.parse(data.trim());
            var comp = new ICAL.Component(jcalData);
            var eventComps = comp.getAllSubcomponents("vevent");
            // map them to FullCalendar events
            var events = $.map(eventComps, function (item) {
                if (item.getFirstPropertyValue("class") == "PRIVATE") {
                    return null;
                }
                else {
                    let start = item.getFirstPropertyValue("dtstart").toJSDate();
                    let end = item.getFirstPropertyValue("dtend").toJSDate();
                    allDay = (moment(start).format('HH:mm') === "00:00"
                        && moment(end).format('HH:mm') === "00:00")
                    return {
                        "title": item.getFirstPropertyValue("summary"),
                        "start": start,
                        "end": end,
                        "location": item.getFirstPropertyValue("location"),
                        "description": replaceUrls(item.getFirstPropertyValue("description")),
                        "allDay": allDay
                    };
                }
            });
            eventSources.push({ 
                events: events,
                color: colors[i]
            });
        }

        $('#calendar{{ .Ordinal }}').fullCalendar({
            locale: 'fr',
            eventSources: eventSources,
            timeFormat: "HH:mm",
            firstDay:1,
            displayEventEnd: false,
            displayEventTime: true,
            themeSystem: 'bootstrap3',
            //height : 300,
            columnHeader:!tiny,
            aspectRatio: tiny?0.8:1.35,
            eventLimit: true,
            eventRender: function (event, element) {

                let infos = "";
                
                if (event.location!=null && event.location!="") {
                    infos += "<div><i>Lieu : " + event.location + "</i></div>" ;
                }

                let heures = "de " + moment(event.start).format('HH:mm') + " à " + moment(event.end).format('HH:mm');
                if (heures === "de 00:00 à 00:00") {
                    heures = "journée entière";
                } 

                if (event.description!=null && event.description!="") {
                    infos += "<div>" + event.description.replace(/\n/g, "<br />") + "</div>" ;
                }

                element.qtip({
                    content: { 
                        text: $(infos), 
                        title: event.title + ' (' + heures + ')'
                    },
                    position: {
                        my: 'top left', 
                        at: 'bottom left',
                    },
                    hide: {
                        fixed: true,
                        delay: 300
                    }
                });
            },
            header: {
                left: 'title',
                center: tiny?'': 'today month,basicWeek,listMonth',
                right: 'prev,next'
            }

        });
        //$('#calendar').fullCalendar('option', 'aspectRatio', 2);
    

    }, function() {
        // error occurred
    });   
});  
</script>